//+------------------------------------------------------------------+
//|                                        Trend Intensity Index.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Trend Intensity Index originaly developed by M.H. Pee            |
//| TASC : 20:06 (Jun 2002) article                                  |
//| "Strong Trends = Strong Profits. Trend Intensity Index"          |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     clrDarkGray
#property indicator_color2     clrDarkGray
#property indicator_color3     clrDeepSkyBlue
#property indicator_color4     clrDeepSkyBlue
#property indicator_color5     clrSandyBrown
#property indicator_color6     clrSandyBrown
#property indicator_style1     STYLE_DOT
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_width5     2
#property indicator_width6     2
#property indicator_minimum  -1
#property indicator_maximum 101
#property strict


//
//
//
//
//

extern int                Length    = 30;            // Calculation length
extern ENUM_APPLIED_PRICE Price     = PRICE_CLOSE;   // Price to use
extern double             LevelHigh = 80;            // High level
extern double             LevelLow  = 20;            // Low level

//
//
//
//
//

double Tii[],Tiiua[],Tiiub[],Tiida[],Tiidb[];
double TiiPosition[];
double prices[],state[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,TiiPosition);
   SetIndexBuffer(1,Tii);
   SetIndexBuffer(2,Tiiua);
   SetIndexBuffer(3,Tiiub);
   SetIndexBuffer(4,Tiida);
   SetIndexBuffer(5,Tiidb);
   SetIndexBuffer(6,prices);
   SetIndexBuffer(7,state);
   
      //
      //
      //
      //
      //
      
      LevelHigh = MathMin(MathMax(LevelHigh,0),100);
      LevelLow  = MathMin(MathMax(LevelLow,0) ,100);
      if (LevelHigh<LevelLow)
         {
            double temp = LevelHigh;
                   LevelHigh = LevelLow;
                   LevelLow  = temp;
         }
         
      //
      //
      //
      //
      //
               
   SetLevelValue(0,LevelHigh);
   SetLevelValue(1,LevelLow);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   if (state[limit]== 1) CleanPoint(limit,Tiiua,Tiiub);
   if (state[limit]==-1) CleanPoint(limit,Tiida,Tiidb);
   for(int i=limit; i>=0; i--)
   {
      double ma = iMA(NULL,0,Length*2,0,MODE_SMA,Price,i);
      prices[i] = iMA(NULL,0,1       ,0,MODE_SMA,Price,i);

      //
      //
      //
      //
      //

         double sumUpDeviations = 0;
         double sumDnDeviations = 0;
               for(int j=0; j<Length && (i+j)<Bars; j++)
               {
                  double diff = prices[i+j]-ma;
                  if (diff>0)
                        sumUpDeviations += diff;
                  else  sumDnDeviations -= diff;
               }               
            
      //
      //
      //
      //
      //

      if ((sumUpDeviations+sumDnDeviations)!=0)
            Tii[i] = 100*sumUpDeviations/(sumUpDeviations+sumDnDeviations);
      else  Tii[i] = 0; 
      
      Tiida[i] = EMPTY_VALUE;
      Tiidb[i] = EMPTY_VALUE;
      Tiiua[i] = EMPTY_VALUE;
      Tiiub[i] = EMPTY_VALUE;
      state[i] = 0;
      TiiPosition[i] = 50;
         if (Tii[i]>LevelHigh) { TiiPosition[i] = 101; state[i] =  1; }
         if (Tii[i]<LevelLow)  { TiiPosition[i] =  -1; state[i] = -1; }
         if (state[i] ==  1) PlotPoint(i,Tiiua,Tiiub,Tii);
         if (state[i] == -1) PlotPoint(i,Tiida,Tiidb,Tii);
   }

   //
   //
   //
   //
   //

   return(0);
}
//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}